<?php
/**
 * 后台用户程序
 * @copyright Copyright (c) 2003 - 2008 myphp.cn (www.myphp.cn)
 * @author lizi http://lizi.name QQ:335006 Mail:335006@gmail.com
 * @version v4.0 2007-06-06
 */
require_once('purview.php'); // 后台安全权限文件
require_once('../include/function.php'); // 调用函数库
require_once('../include/page.class.php'); // 调用分页类
/**
 +-------------------------------------------------------------------
 * 主体处理程序 $act
 +-------------------------------------------------------------------
 * list  数据列表
 * view  详细资料
 * create  创建用户
 * createsave  创建用户提交
 * edit  编辑列表
 * editsave  编辑用户提交
 * groupconfirm 批量处理确认
 * group 批量处理
 * delconfirm 确认删除
 * del 正式删除
 +-------------------------------------------------------------------
 */
$act = empty($_GET['act']) ? 'list' : $_GET['act'];

switch($act) {

	case 'list':

		// - 参数设置
		$ser = $_GET['ser'];
		$perpage = empty($_GET['pe']) ? 10 : $_GET['pe']; // 每页显示记录条数
		$page    = empty($_GET['page']) ? 1 : $_GET['page']; // 当页页数
		$pbegin  = ($page * $perpage - $perpage) < 0 ? 0 : $page * $perpage - $perpage; // 起始数据

		if($ser == 1) {
			$did       = $_GET['did']; // 目录id
			$key       = $_GET['key']; // 字段
			$available = $_GET['available']; // 是否可用
			$ss        = $_GET['ss']; // 搜索字段
			$order     = empty($_GET['order']) ? 'time' : $_GET['order']; // 排序
			$sc        = empty($_GET['sc']) ? 'desc' : $_GET['sc']; // 排序方式

			$smarty->assign('ser', $ser);
			$smarty->assign('did', $did);
			$smarty->assign('key', $key);
			$smarty->assign('available', $available);
			$smarty->assign('ss', $ss);
			$smarty->assign('pe', $perpage);
			$smarty->assign('order', $order);
			$smarty->assign('sc', $sc);
			$smarty->assign('b_skins', $skins); // 当前默认模板

			if ($available == 0) {
				$avail = 'available=0 and';
			} elseif ($available == 1) {
				$avail = 'available=1 and ';
			} else {
				$avail = '';
			}

			if ($did == 0) {
				$did = '';
			} else {
				$did = "groupid=$did ";
			}

			if ($key == 'id') {
				$total = 1; // 总记录条数
			} else {
				$tal     = $db->getarray($db->query("select COUNT(*) as total from {$prefix}_members where $avail $did and $key LIKE '%$ss%'")); // 总记录条数
				$total   = $tal['total'];
			}

		} else {

			$stime   = (date("Y")-1)."-".date("m-d"); // 开始时间
			$etime   = date("Y-m-d"); // 结束时间
			$tal     = $db->getarray($db->query("select COUNT(*) as total from {$prefix}_members order by uid asc")); // 总记录条数
			$total   = $tal['total'];
			$smarty->assign('stime', $stime);
			$smarty->assign('etime', $etime);
		}

		// - 输出目录列表

		$re0s = $db->query("select * from {$prefix}_groups order by id asc limit 0,200");
		while($re0r = $db->getarray($re0s)) {
			$manager_dir_list_array[] = smarrayall($re0r);
		}
		$smarty->assign('manager_dir_list', $manager_dir_list_array);

		// - 输出列表
		if($ser == 1) {
			if ($key == 'id') {
				$re1s = $db->query("select * from {$prefix}_members where uid='$ss'"); // sql
			} else {
				$re1s = $db->query("select * from {$prefix}_members where $avail $did and $key LIKE '%".$ss."%' order by $order $sc limit $pbegin,$perpage"); // sql
			}
		} else {
			$re1s = $db->query("select * from {$prefix}_members order by uid desc limit $pbegin,$perpage");
		}
		while($re1r = $db->getarray($re1s)) {
			$did  = $re1r['did'];
			$re2s = $db->query("select * from {$prefix}_groups where id={$re1r['groupid']}");
			$re2r = $db->getarray($re2s);
			$re1r['d_title'] = $re2r['title'];
			$manager_list_array[] = smarrayall($re1r);
		}
		$smarty->assign('manager_list', $manager_list_array);

		// - 分页

		$fpage = new page(array('total'=>$total, 'perpage'=>$perpage)); // 调用分页
		$smarty->assign('page', $fpage->show(2)); // 输出分页
		$smarty->assign('url', base64_encode($fpage->_get_url($page))); // 记住url，以便返回

		break;

	case 'create':

		$smarty->assign('html', $html); // 用来控制可视化编辑器

		// - 输出目录列表

		$re1s = $db->query("select * from {$prefix}_groups order by id asc limit 0,200");
		while($re1r = $db->getarray($re1s)) {
			$manager_dir_list_array[] = smarrayall($re1r);
		}
		$smarty->assign('manager_dir_list', $manager_dir_list_array);

		break;


	case 'createsave':

		$username  = $_POST['username']; // 用户名
		$password  = $_POST['password']; // 密码
		$password2 = $_POST['password2']; // 英文标题
		$jumpurl = 'manager.php?act=create'; // 跳转链接，默认返回
		if (empty($username) && empty($password) && empty($password2)) {
			$message = '用户名、密码不能为空';
		} else {
			$re2s = $db->query("select * from {$prefix}_members where username='$username'");
			$re2r = $db->getarray($re2s);
			if ($re2r) {
				$message = '该用户名已经被使用，正在返回..';
			} else {

				// - 参数设置

				$_POST['regdate']  = time();
				$_POST['regip']    = getip();
				$_POST['password'] = md5($_POST['password']);

				// - 插入数据表
				$db->insert_list("{$prefix}_members", $_POST, '|username|password|gender|adminid|groupid|regip|regdate|lastactivity|lastpost|posts|oltime|pageviews|credits|email|bday|invisible|available|truename|byear|bmonth|idtype|idcard|city|industry|edulevel|occupation|income|telephone|mobile|address|postid|homepage|qq|msn|alipay|avatar|content');
				$message = $username.'已经添加成功,正在返回用户列表!';
				$jumpurl = 'manager.php?act=list'; // 成功后跳转回

			}

		}
		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;

	case 'edit':

		// - 安全检查、变量设置

		$id  = f_int($_GET['id']);
		$url = $_GET['url'];
		$smarty->assign('id', $id); // 定义显示url
		$smarty->assign('url', $url); // 定义显示url

		// - 输出目录列表

		$re0s = $db->query("select * from {$prefix}_groups order by id asc limit 0,200");
		while($re0r = $db->getarray($re0s)) {
			$manager_dir_list_array[] = smarrayall($re0r);
		}
		$smarty->assign('manager_dir_list', $manager_dir_list_array);

		// - 输出编辑列表
		$re1s = $db->query("select * from {$prefix}_members where uid = '$id'");
		$re1r = $db->getarray($re1s);
		$editlist = smarrayall($re1r);
		$smarty->assign('edit', $editlist); // 定义显示数组

		break;

	case 'editsave':

		// - 安全检查、变量设置
		$id       = f_int($_POST['id']);
		$username  = $_POST['username']; // 用户名

		$jumpurl = 'manager.php?act=create'; // 跳转链接，默认返回
		if (empty($username)) {
			$message = '用户名不能为空';
		} else {

			// - 设定参数
			$condition    = 'uid='.$id; // 条件

			// - 处理密码
			if (!empty($_POST['password'])) {
				$_POST['password'] = md5($_POST['password']);
				$db->update_list("{$prefix}_members", $_POST, $condition, '|password');
			}


			// - 更改其它数据

			// - 编辑数据
			$db->update_list("{$prefix}_members", $_POST, $condition, '|username|gender|adminid|groupid|lastactivity|lastpost|posts|oltime|pageviews|credits|email|bday|invisible|available|truename|byear|bmonth|idtype|idcard|city|industry|edulevel|occupation|income|telephone|mobile|address|postid|homepage|qq|msn|alipay|avatar|content');
			$message = $username.'已经编辑成功,正在返回!';
			$jumpurl = base64_decode($_GET['url']); // 成功后跳转回


		}
		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;

	case 'view':

		// - 安全检查
		$id = f_int($_GET['id']);

		// - 输出列表
		$re1s = $db->query("select * from {$prefix}_members where uid = '$id'");
		$re1r = $db->getarray($re1s);
		$re2s = $db->query("select * from {$prefix}_groups where id = {$re1r['groupid']}");
		$re2r = $db->getarray($re2s);
		$re1r['groupname'] = $re2r['title'];
		$re1r['time'] = date("Y-m-d H:s" ,$re1r['time']);
		$viewlist = smarrayall($re1r);
		$smarty->assign('view', $viewlist); // 定义显示数组

		break;

	case 'groupconfirm':

		// - 设定参数
		$url       = $_GET['url'];
		$operation = $_POST['operation'];
		$moderate  = $_POST['moderate'];
		$did       = $_POST['did'];

		if ($operation == 'available') {
			$operationtxt = '<font color=#0066ff>有效</font>';
		} elseif ($operation == 'del') {
			$operationtxt = '<font color=#FF5B5B>删除</font>';
		} elseif ($operation == 'passed') {
			$operationtxt = '<font color=#006600>审核</font>';
		} elseif ($operation == 'move') {
			$operationtxt = '<font color=#000000>批移</font>';
		}
		if (empty($moderate)) {
			$smarty->assign('message', '您没有选择任选项,请返回重新选择!'); // 跳转消息
			$smarty->assign('jumpurl', base64_decode($_GET['url'])); // 跳转url
			$smarty->assign('jumptime', 2); // 跳转时间
			$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
			exit();
		}
		foreach ($moderate as $val) {
			$moderatelist = $moderatelist.$val.',';
			$re1s         = $db->query("select * from {$prefix}_members where uid = '$val'");
			$re1r         = $db->getarray($re1s);
			$message     .= '确认要'.$operationtxt.$re1r['username'].'吗..<br>';
		}
		$moderatelist = substr($moderatelist, 0, -1);

		$action  = 'manager.php?act=group&operation='.$operation.'&moderatelist='.$moderatelist.'&did='.$did.'&url='.$url;

		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('action', $action); // 跳转url
		$smarty->display('skins/'.$b_skins.'/zt_confirm.html');
		exit();

		break;

	case 'group':

		// - 设定参数
		$operation    = $_GET['operation'];
		$moderatelist = $_GET['moderatelist'];
		$did          = $_GET['did'];
		$moderate     = explode(",", $moderatelist);

		// - 操作
		if ($operation == 'available') { // 选择可用操作
			$operationtxt = '<font color=#0066ff>有效</font>';
			foreach ($moderate as $val) {
				$re1s = $db->query("select available,username from {$prefix}_members where uid = '$val'");
				$re1r = $db->getarray($re1s);
				if ($re1r['available'] == 0) {
					$db->update("update {$prefix}_members set available=1 where uid='$val'");
				} else {
					$db->update("update {$prefix}_members set available=0 where uid='$val'");
				}
				$message .= $re1r['username'].'已经'.$operationtxt.'操作成功..<br>';
			}
		} elseif ($operation == 'del') { // 选择删除操作
			$operationtxt = '<font color=#FF5B5B>删除</font>';
			foreach ($moderate as $val) {
				$re1s = $db->query("select username from {$prefix}_members where uid = '$val'");
				$re1r = $db->getarray($re1s);
				// 删除操作
				$db->del("delete from {$prefix}_members where uid='$val'");
				$message .= $re1r['username'].'已经'.$operationtxt.'操作成功..<br>';
			}
		} elseif ($operation == 'passed') { // 选择审核操作
			$operationtxt = '<font color=#006600>审核</font>';
			foreach ($moderate as $val) {
				$re1s = $db->query("select passed,username from {$prefix}_members where uid = '$val'");
				$re1r = $db->getarray($re1s);
				if ($re1r['passed'] == 0) {
					$db->update("update {$prefix}_members set passed=1 where uid='$val'");
				} else {
					$db->update("update {$prefix}_members set passed=0 where uid='$val'");
				}
				$message .= $re1r['username'].'已经'.$operationtxt.'操作成功..<br>';
			}
		} elseif ($operation == 'move') { // 批量移动到目录
			$operationtxt = '<font color=#000000>批移</font>';
			foreach ($moderate as $val) {
				$re1s = $db->query("select username from {$prefix}_members where uid = '$val'");
				$re1r = $db->getarray($re1s);
				$db->update("update {$prefix}_members set groupid='$did' where uid='$val'");
				$message .= $re1r['username'].'已经'.$operationtxt.'操作成功..<br>';
			}
		}

		// 跳转
		$jumpurl = base64_decode($_GET['url']); // 跳转回路径
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;

	case 'delconfirm':

		$id      = f_int($_GET['id']);
		$url     = $_GET['url'];
		$re1s    = $db->query("select * from {$prefix}_members where uid = '$id'");
		$re1r    = $db->getarray($re1s);
		$action  = 'manager.php?act=del&id='.$id.'&page='.$page.'&url='.$url;
		$message = '确认要删除'.$re1r['username'].'吗';

		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('action', $action); // 跳转url
		$smarty->display('skins/'.$b_skins.'/zt_confirm.html');
		exit();

		break;

	case 'del':

		// 提交示例manager.php?act=del&id=5
		$id      = f_int($_GET['id']);
		$re1s    = $db->query("select * from {$prefix}_members where uid = '$id'");
		$re1r    = $db->getarray($re1s);
		$message = $re1r['username'].'已经被删除,正在返回!';
		$jumpurl = base64_decode($_GET['url']);

		// 删除操作
		$db->del("delete from {$prefix}_members where uid='$id'");

		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;

	case '';

	break;
}

/**
 +-------------------------------------------------------------------
 * 调用用户文件
 +-------------------------------------------------------------------
 */
// 程序结束时间
$smarty->assign('ptime', ptime($time_start));
$smarty->assign('act', $act);
$smarty->display('skins/'.$b_skins.'/zt_manager.html');
?>