<?php
/**
 * 后台案例程序
 * @copyright Copyright (c) 2003 - 2008 myphp.cn (www.myphp.cn)
 * @author lizi http://lizi.name QQ:335006 Mail:335006@gmail.com
 * @version v4.0 2007-06-06
 */
require_once('purview.php'); // 后台安全权限文件
require_once('../include/function.php'); // 调用函数库
require_once('../include/page.class.php'); // 调用分页类
require_once('../include/uploadfile.class.php'); // 调用上传类
/**
 +-------------------------------------------------------------------
 * 主体处理程序 $act
 +-------------------------------------------------------------------
 * list  数据列表
 * view  详细资料
 * create  创建案例
 * createsave  创建案例提交
 * edit  编辑列表
 * editsave  编辑案例提交
 * groupconfirm 批量处理确认
 * group 批量处理
 * delconfirm 确认删除
 * del 正式删除
 +-------------------------------------------------------------------
 */
$act = empty($_GET['act']) ? 'list' : $_GET['act'];

switch($act) {

	case 'list':

		// - 参数设置
		$ser = $_GET['ser'];
		$perpage = empty($_GET['pe']) ? 10 : $_GET['pe']; // 每页显示记录条数
		$page    = empty($_GET['page']) ? 1 : $_GET['page']; // 当页页数
		$pbegin  = ($page * $perpage - $perpage) < 0 ? 0 : $page * $perpage - $perpage; // 起始数据

		if($ser == 1) {
			$p_estate  = $_GET['p_estate']; // 支付状态
			$paytype   = $_GET['paytype']; // 支付方式
			$key       = $_GET['key']; // 字段
			$available = $_GET['available']; // 是否可用
			$stime     = $_GET['stime']; // 开始时间
			$etime     = $_GET['etime']; // 结束时间
			$ss        = $_GET['ss']; // 搜索字段
			$order     = empty($_GET['order']) ? 'time' : $_GET['order']; // 排序
			$sc        = empty($_GET['sc']) ? 'desc' : $_GET['sc']; // 排序方式

			$smarty->assign('ser', $ser);
			$smarty->assign('p_estate', $p_estate);
			$smarty->assign('paytype', $paytype);
			$smarty->assign('key', $key);
			$smarty->assign('ss', $ss);
			$smarty->assign('stime', $stime);
			$smarty->assign('etime', $etime);
			$smarty->assign('pe', $perpage);
			$smarty->assign('order', $order);
			$smarty->assign('sc', $sc);
			$smarty->assign('b_skins', $skins); // 当前默认模板



			if ($p_estate == 3) {
				$p_estate = '';
			} else {
				$p_estate = "p_estate=$p_estate and ";
			}

			if ($paytype == 0) {
				$paytype = '';
			} else {

				$paytype = "paytype=$paytype and ";

			}

			//			$time1 = explode('-', $stime);
			//			$time2 = explode('-', $etime);
			//			$stime = @mktime( 0, 0, 0, $time1[1], $time1[2], $time1[0]);
			//			$etime = @mktime( 24, 0, 0, $time2[1], $time2[2], $time2[0]);

			$stime = strtotime($stime);
			$etime = strtotime($etime) + 24*3600;

			if ($key == 'id') {
				$total = 1; // 总记录条数
			} else {
				$tal     = $db->getarray($db->query("select COUNT(*) as total from {$prefix}_product_orders where $p_estate $paytype (time >= $stime and time <= $etime) and $key LIKE '%$ss%'")); // 总记录条数
				$total   = $tal['total'];
			}

		} else {

			$stime   = (date("Y")-1)."-".date("m-d"); // 开始时间
			$etime   = date("Y-m-d"); // 结束时间
			$tal     = $db->getarray($db->query("select COUNT(*) as total from {$prefix}_product_orders order by id asc")); // 总记录条数
			$total   = $tal['total'];
			$smarty->assign('stime', $stime);
			$smarty->assign('etime', $etime);
		}


		// - 输出列表
		if($ser == 1) {
			if ($key == 'id') {
				$re1s = $db->query("select * from {$prefix}_product_orders where id='$ss'"); // sql
			} else {
				$re1s = $db->query("select * from {$prefix}_product_orders where $p_estate $paytype (time >= $stime and time <= $etime) and $key LIKE '%".$ss."%' order by $order $sc limit $pbegin,$perpage"); // sql
			}
		} else {
			$re1s = $db->query("select * from {$prefix}_product_orders order by time desc,id desc limit $pbegin,$perpage");
		}
		while($re1r = $db->getarray($re1s)) {
			$re1r['time'] = date("Y-m-d H:i", $re1r['time']);
			$product_order_list_array[] = smarrayall($re1r);
		}
		$smarty->assign('product_order_list', $product_order_list_array);

		// - 分页

		$fpage = new page(array('total'=>$total, 'perpage'=>$perpage)); // 调用分页
		$smarty->assign('page', $fpage->show(2)); // 输出分页
		$smarty->assign('url', base64_encode($fpage->_get_url($page))); // 记住url，以便返回

		break;



	case 'edit':

		// - 安全检查、变量设置

		$id   = f_int($_GET['id']);
		$url = $_GET['url'];
		$smarty->assign('id', $id); // 定义显示url
		$smarty->assign('url', $url); // 定义显示url



		// - 输出编辑列表
		$re1s = $db->query("select * from {$prefix}_product_orders where id = '$id'");
		$re1r = $db->getarray($re1s);
		$re1r['timed'] = date("Y-m-d",$re1r['time']);
		$re1r['timet'] = date("H:i:s",$re1r['time']);
		$editlist = smarrayall($re1r);
		$smarty->assign('edit', $editlist); // 定义显示数组

		break;

	case 'editsave':

		// - 安全检查、变量设置
		$id       = f_int($_POST['id']);
		$jumpurl = 'product_order.php?act=create'; // 跳转链接，默认返回

		// - 设定参数
		$condition    = 'id='.$id; // 条件


		// - 编辑数据
		$db->update_list("{$prefix}_product_orders", $_POST, $condition, '|cproduct|p_userid|time|tono|subject|body|price|url|number|p_username|phone|gender|deliver|city|address|postalcode|dtime|mob|email|content|paytype|p_estate|c_cart');
		$message = $tono.'已经编辑成功,正在返回!';
		$jumpurl = base64_decode($_GET['url']); // 成功后跳转回

		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;

	case 'view':

		// - 安全检查
		$id = f_int($_GET['id']);

		// - 输出列表
		$re1s = $db->query("select * from {$prefix}_product_orders where id = '$id'");
		$re1r = $db->getarray($re1s);
		$re1r['time'] = date("Y-m-d H:s" ,$re1r['time']);
		$viewlist = smarrayall($re1r);
		$smarty->assign('view', $viewlist); // 定义显示数组


		$t = 0;
		$list = explode('/', $re1r['c_cart']);
		for($i=0; $list[$i]!=''; $i++) {
			$record = explode(',', $list[$i]);
			$re1s = $db->query("select * from {$prefix}_product where id=$record[0]");
			$re1r = $db->getarray($re1s);
			$t = $t+1;
			$ctotal = $record[1]*$re1r['price2'];
			$totalprice = $totalprice + $record[1] * $re1r['price2'];
			$re1r['num']    = $record[1];
			$re1r['t']      = $t;
			$re1r['coid']   = $record[0];
			$re1r['ctotal'] = $ctotal;
			$carray[] = smarrayall($re1r);
		}
		$smarty->assign('clist', $carray);

		break;

	case 'groupconfirm':

		// - 设定参数
		$url       = $_GET['url'];
		$operation = $_POST['operation'];
		$moderate  = $_POST['moderate'];
		$did       = $_POST['did'];

		if ($operation == 'available') {
			$operationtxt = '<font color=#0066ff>显示</font>';
		} elseif ($operation == 'del') {
			$operationtxt = '<font color=#FF5B5B>删除</font>';
		} elseif ($operation == 'passed') {
			$operationtxt = '<font color=#006600>审核</font>';
		} elseif ($operation == 'move') {
			$operationtxt = '<font color=#000000>批移</font>';
		}
		if (empty($moderate)) {
			$smarty->assign('message', '您没有选择任选项,请返回重新选择!'); // 跳转消息
			$smarty->assign('jumpurl', base64_decode($_GET['url'])); // 跳转url
			$smarty->assign('jumptime', 2); // 跳转时间
			$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
			exit();
		}
		foreach ($moderate as $val) {
			$moderatelist = $moderatelist.$val.',';
			$re1s         = $db->query("select tono from {$prefix}_product_orders where id = '$val'");
			$re1r         = $db->getarray($re1s);
			$message     .= '确认要'.$operationtxt.$re1r['tono'].'吗..<br>';
		}
		$moderatelist = substr($moderatelist, 0, -1);

		$action  = 'product_order.php?act=group&operation='.$operation.'&moderatelist='.$moderatelist.'&did='.$did.'&url='.$url;

		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('action', $action); // 跳转url
		$smarty->display('skins/'.$b_skins.'/zt_confirm.html');
		exit();

		break;

	case 'group':

		// - 设定参数
		$operation    = $_GET['operation'];
		$moderatelist = $_GET['moderatelist'];
		$did          = $_GET['did'];
		$moderate     = explode(",", $moderatelist);

		// - 操作
		if ($operation == 'available') { // 选择可用操作
			$operationtxt = '<font color=#0066ff>显示</font>';
			foreach ($moderate as $val) {
				$re1s = $db->query("select available,tono from {$prefix}_product_orders where id = '$val'");
				$re1r = $db->getarray($re1s);
				if ($re1r['available'] == 0) {
					$db->update("update {$prefix}_product_orders set available=1 where id='$val'");
				} else {
					$db->update("update {$prefix}_product_orders set available=0 where id='$val'");
				}
				$message .= $re1r['tono'].'已经'.$operationtxt.'操作成功..<br>';
			}
		} elseif ($operation == 'del') { // 选择删除操作
			$operationtxt = '<font color=#FF5B5B>删除</font>';
			foreach ($moderate as $val) {
				$re1s = $db->query("select tono from {$prefix}_product_orders where id = '$val'");
				$re1r = $db->getarray($re1s);
				// 删除图片操作
				if (!empty($re1r['pic'])) {
					@unlink("../upload/system/".$re1r['pic']);
				}
				// 删除操作
				$db->del("delete from {$prefix}_product_orders where id='$val'");
				$message .= $re1r['tono'].'已经'.$operationtxt.'操作成功..<br>';
			}
		} elseif ($operation == 'passed') { // 选择审核操作
			$operationtxt = '<font color=#006600>审核</font>';
			foreach ($moderate as $val) {
				$re1s = $db->query("select passed,tono from {$prefix}_product_orders where id = '$val'");
				$re1r = $db->getarray($re1s);
				if ($re1r['passed'] == 0) {
					$db->update("update {$prefix}_product_orders set passed=1 where id='$val'");
				} else {
					$db->update("update {$prefix}_product_orders set passed=0 where id='$val'");
				}
				$message .= $re1r['tono'].'已经'.$operationtxt.'操作成功..<br>';
			}
		} elseif ($operation == 'move') { // 批量移动到目录
			$operationtxt = '<font color=#000000>批移</font>';
			foreach ($moderate as $val) {
				$re1s = $db->query("select tono from {$prefix}_product_orders where id = '$val'");
				$re1r = $db->getarray($re1s);
				$db->update("update {$prefix}_product_orders set did='$did' where id='$val'");
				$message .= $re1r['tono'].'已经'.$operationtxt.'操作成功..<br>';
			}
		}

		// 跳转
		$jumpurl = base64_decode($_GET['url']); // 跳转回路径
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;

	case 'delconfirm':

		$id      = f_int($_GET['id']);
		$url     = $_GET['url'];
		$re1s    = $db->query("select * from {$prefix}_product_orders where id = '$id'");
		$re1r    = $db->getarray($re1s);
		$action  = 'product_order.php?act=del&id='.$id.'&page='.$page.'&url='.$url;
		$message = '确认要删除'.$re1r['tono'].'吗';

		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('action', $action); // 跳转url
		$smarty->display('skins/'.$b_skins.'/zt_confirm.html');
		exit();

		break;

	case 'del':

		// 提交示例product_order.php?act=del&id=5
		$id      = f_int($_GET['id']);
		$re1s    = $db->query("select * from {$prefix}_product_orders where id = '$id'");
		$re1r    = $db->getarray($re1s);
		$message = $re1r['tono'].'已经被删除,正在返回!';
		$jumpurl = base64_decode($_GET['url']);
		// 删除图片操作
		if (!empty($re1r['pic'])) {
			@unlink("../upload/system/".$re1r['pic']);
		}
		// 删除操作
		// 删除操作
		$db->del("delete from {$prefix}_product_orders where id='$id'");

		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;


}

/**
 +-------------------------------------------------------------------
 * 调用案例文件
 +-------------------------------------------------------------------
 */
// 程序结束时间
$smarty->assign('ptime', ptime($time_start));
$smarty->assign('act', $act);
$smarty->display('skins/'.$b_skins.'/zt_product_order.html');
?>