<?php
/**
 * 后台资源标签程序
 * @copyright Copyright (c) 2003 - 2008 myphp.cn (www.myphp.cn)
 * @author lizi http://lizi.name QQ:335006 Mail:335006@gmail.com
 * @version v1.1 2007-06-05
 */
require_once('purview.php'); // 后台安全权限文件
require_once('../include/function.php'); // 调用函数库
require_once('../include/page.class.php'); // 调用分页类
/**
 +-------------------------------------------------------------------
 * 主体处理程序 $act
 +-------------------------------------------------------------------
 * list  数据列表
 * view  详细资料
 * create  创建资源
 * createsave  创建资源提交
 * edit  编辑列表
 * editsave  编辑资源提交
 * groupconfirm 批量处理确认
 * group 批量处理
 * delconfirm 确认删除
 * del 正式删除
 +-------------------------------------------------------------------
 */
$act = empty($_GET['act']) ? 'list' : $_GET['act'];

switch($act) {

	case 'list':

		// - 参数设置
		$perpage = empty($_GET['pe']) ? 10 : $_GET['pe']; // 每页显示记录条数
		$page    = empty($_GET['page']) ? 1 : $_GET['page']; // 当页页数
		$pbegin  = ($page * $perpage - $perpage) < 0 ? 0 : $page * $perpage - $perpage; // 起始数据
		$tal     = $db->getarray($db->query("select COUNT(*) as total from {$prefix}_resource_dir_include order by id asc")); // 总记录条数
		$total   = $tal['total'];

		// - 输出列表

		$re1s = $db->query("select * from {$prefix}_resource_dir_include order by id asc limit $pbegin,$perpage");
		while($re1r = $db->getarray($re1s)) {
			$resource_dir_include_list_array[] = smarrayall($re1r);
		}
		$smarty->assign('resource_dir_include_list', $resource_dir_include_list_array);

		// - 分页

		$fpage = new page(array('total'=>$total, 'perpage'=>$perpage)); // 调用分页
		$smarty->assign('page', $fpage->show(2)); // 输出分页
		$smarty->assign('url', base64_encode($fpage->_get_url($page))); // 记住url，以便返回

		break;

	case 'create':

		// - 输出模板列表
		$handle = @opendir('../skins');
		while ($file = @readdir($handle)) {
			if($file!="." and $file!=".." and is_dir("../skins/".$file)==true){
				$skins_list_array[] = $file;
			}
		}

		$smarty->assign('skins_list', $skins_list_array);
		$smarty->assign('b_skins', $skins); // 当前默认模板 // 当前默认模板

		// - 输出目录列表

		$re1s = $db->query("select * from {$prefix}_resource_dir order by compositor asc,id asc limit 0,200");
		while($re1r = $db->getarray($re1s)) {
			$resource_dir_list_array[] = smarrayall($re1r);
		}
		$smarty->assign('resource_dir_list', $resource_dir_list_array);

		break;

	case 'createsave':

		$dirs = $_POST['dirs'];
		foreach ($dirs as $val) {
			$dirslist = $dirslist.$val.'|';
		}
		$dirslist = substr($dirslist, 0, -1);

		if(empty($dirslist)) {
			$dirslist = 0;
		}

		$title = $_POST['title']; // 标题
		$jumpurl = 'resource_dir_include.php?act=create'; // 跳转链接，默认返回
		if (empty($title)) {
			$message = '标题不能为空';
		} else {
			// - 插入数据表
			$_POST['dirs'] = $dirslist;
			$db->insert_list("{$prefix}_resource_dir_include", $_POST, '|title|skins|dirs|resourcetype|available|content');
			$message = $title.'已经添加成功,正在返回资源列表!';
			$jumpurl = 'resource_dir_include.php?act=list'; // 成功后跳转回
		}
		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();


		break;

	case 'edit':

		// - 安全检查、变量设置

		$id   = f_int($_GET['id']);
		$url  = $_GET['url'];
		$smarty->assign('id', $id); // 定义显示url
		$smarty->assign('url', $url); // 定义显示url


		// - 输出编辑列表
		$re0s = $db->query("select * from {$prefix}_resource_dir_include where id = '$id'");
		$re0r = $db->getarray($re0s);
		$editlist = smarrayall($re0r);
		$smarty->assign('edit', $editlist); // 定义显示数组

		// - 输出模板列表
		$handle = @opendir('../skins');
		while ($file = @readdir($handle)) {
			if($file!="." and $file!=".." and is_dir("../skins/".$file)==true) {
				$skins_list_array[] = $file;
			}
		}

		$smarty->assign('skins_list', $skins_list_array);
		$smarty->assign('b_skins', $skins); // 当前默认模板 // 当前默认模板

		// - 输出目录列表

		$re1s = $db->query("select * from {$prefix}_resource_dir order by compositor asc,id asc limit 0,200");
		while($re1r = $db->getarray($re1s)) {
			$re1r['dc'] = strstr($re0r['dirs'], $re1r['id']) ? 1 : 0;
			$resource_dir_list_array[] = smarrayall($re1r);
		}
		$smarty->assign('resource_dir_list', $resource_dir_list_array);

		break;


	case 'editsave':

		// - 安全检查、变量设置
		$id   = $_POST['id'];
		$dirs = $_POST['dirs'];
		foreach ($dirs as $val) {
			$dirslist = $dirslist.$val.'|';
		}
		$dirslist = substr($dirslist, 0, -1);

		if(empty($dirslist)) {
			$dirslist = 0;
		}

		$title = $_POST['title']; // 标题
		$jumpurl = 'resource_dir_include.php?act=list'; // 跳转链接，默认返回
		if (empty($title)) {
			$message = '标题不能为空';
		} else {

			// - 设定参数
			$_POST['dirs'] = $dirslist;

			// - 编辑数据
			$condition = 'id='.$id; // 条件
			$db->update_list("{$prefix}_resource_dir_include", $_POST, $condition, '|title|skins|dirs|resourcetype|available|content');
			$message = $cn_title.'已经编辑成功,正在返回!';
			$jumpurl = base64_decode($_GET['url']); // 成功后跳转回

		}
		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;

	case 'view':

		// - 安全检查
		$id = f_int($_GET['id']);

		// - 输出列表
		$re1s = $db->query("select * from {$prefix}_resource_dir_include where id = '$id'");
		$re1r = $db->getarray($re1s);
		$re1r['time'] = date("Y-m-d H:s" ,$re1r['time']);
		$viewlist = smarrayall($re1r);
		$smarty->assign('view', $viewlist); // 定义显示数组

		break;

	case 'groupconfirm':

		// - 设定参数
		$url       = $_GET['url'];
		$operation = $_POST['operation'];
		$moderate  = $_POST['moderate'];
		if ($operation == 'available') {
			$operationtxt = '<font color=#0066ff>显示</font>';
		} elseif ($operation == 'del') {
			$operationtxt = '<font color=#FF5B5B>删除</font>';
		}
		if (empty($moderate)) {
			$smarty->assign('message', '您没有选择任选项,请返回重新选择!'); // 跳转消息
			$smarty->assign('jumpurl', base64_decode($_GET['url'])); // 跳转url
			$smarty->assign('jumptime', 2); // 跳转时间
			$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
			exit();
		}
		foreach ($moderate as $val) {
			$moderatelist = $moderatelist.$val.',';
			$re1s         = $db->query("select * from {$prefix}_resource_dir_include where id = '$val'");
			$re1r         = $db->getarray($re1s);
			$message     .= '确认要'.$operationtxt.$re1r['cn_title'].'吗..<br>';
		}
		$moderatelist = substr($moderatelist, 0, -1);

		$action  = 'resource_dir_include.php?act=group&operation='.$operation.'&moderatelist='.$moderatelist.'&url='.$url;

		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('action', $action); // 跳转url
		$smarty->display('skins/'.$b_skins.'/zt_confirm.html');
		exit();

		break;

	case 'group':

		// - 设定参数
		$operation    = $_GET['operation'];
		$moderatelist = $_GET[moderatelist];
		$moderate     = explode(",",$moderatelist);

		// - 操作
		if ($operation == 'available') { // 选择可用操作
			$operationtxt = '<font color=#0066ff>显示</font>';
			foreach ($moderate as $val) {
				$re1s = $db->query("select * from {$prefix}_resource_dir_include where id = '$val'");
				$re1r = $db->getarray($re1s);
				if ($re1r['available'] == 0) {
					$db->update("update {$prefix}_resource_dir_include set available=1 where id='$val'");
				} else {
					$db->update("update {$prefix}_resource_dir_include set available=0 where id='$val'");
				}
				$message .= $re1r['cn_title'].'已经'.$operationtxt.'操作成功..<br>';
			}
		} elseif ($operation == 'del') { // 选择删除操作
			$operationtxt = '<font color=#FF5B5B>删除</font>';
			foreach ($moderate as $val) {
				$re1s = $db->query("select * from {$prefix}_resource_dir_include where id = '$val'");
				$re1r = $db->getarray($re1s);
				$db->del("delete from {$prefix}_resource_dir_include where id='$val'");
				$message .= $re1r['cn_title'].'已经'.$operationtxt.'操作成功..<br>';
			}
		}

		// 跳转
		$jumpurl = base64_decode($_GET['url']); // 跳转回路径
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;

	case 'delconfirm':

		$id      = f_int($_GET['id']);
		$url     = $_GET['url'];
		$re1s    = $db->query("select * from {$prefix}_resource_dir_include where id = '$id'");
		$re1r    = $db->getarray($re1s);
		$action  = 'resource_dir_include.php?act=del&id='.$id.'&page='.$page.'&url='.$url;
		$message = '确认要删除'.$re1r['cn_title'].'吗';

		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('action', $action); // 跳转url
		$smarty->display('skins/'.$b_skins.'/zt_confirm.html');
		exit();

		break;

	case 'del':

		// 提交示例resource_dir_include.php?act=del&id=5
		$id      = f_int($_GET['id']);
		$re1s    = $db->query("select * from {$prefix}_resource_dir_include where id = '$id'");
		$re1r    = $db->getarray($re1s);
		$message = $re1r['cn_title'].'已经被删除,正在返回!';
		$jumpurl = base64_decode($_GET['url']);
		// 删除操作
		$db->del("delete from {$prefix}_resource_dir_include where id='$id'");

		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;
}

/**
 +-------------------------------------------------------------------
 * 调用资源文件
 +-------------------------------------------------------------------
 */
// 程序结束时间
$smarty->assign('ptime', ptime($time_start));
$smarty->assign('act', $act);
$smarty->display('skins/'.$b_skins.'/zt_resource_dir_include.html');
?>